# -*- coding: utf-8 -*-
from abc import ABC

'''
平台能力扩展，在数据处理步骤进行预处理或者后置处理
'''


class HandlerAbstract(ABC):
    def __init__(self, processor):
        self.processor = processor
        self.partition = None

    def pre_handler(self):
        pass

    def post_handler(self):
        pass

    def get_oss_path_by_relative_path(self, relative_path):
        if self.partition is None:
            self.partition = self.processor.read_client.get_data_partition()

        return self.partition["contentMap"]["OSS"]["rootPath"][1:] + relative_path

    def get_local_path_by_relative_path(self, relative_path):
        if self.partition is None:
            self.partition = self.processor.read_client.get_data_partition()

        return self.partition["contentMap"]["OSS"]["localRelativeRootPath"] + relative_path
