# -*-coding:utf-8-*-

import logging
import os

_formatter = logging.Formatter('%(asctime)s [%(levelname)s] [%(process)d (%(filename)s:%(lineno)d)] %(message)s')

default_file = 'default'
log_file_path = os.getcwd() + "/logs"

def filename(instanceCode):
    if not os.path.exists(log_file_path):
        os.makedirs(log_file_path)
    return '%s/%s.log' % (log_file_path, instanceCode)

def _log(filename):
    logger = logging.getLogger(filename)
    logger.setLevel(logging.DEBUG)
    fileHander = logging.FileHandler(filename, encoding = 'utf-8', mode='a')
    fileHander.setLevel(logging.INFO)
    fileHander.setFormatter(_formatter)
    logger.addHandler(fileHander)
    streamHandler = logging.StreamHandler()
    streamHandler.setLevel(logging.DEBUG)
    streamHandler.setFormatter(_formatter)
    logger.addHandler(streamHandler)
    return logger

"""
根据实例code返回对应的logger
"""
def get_log(instanceCode):
    return _log(filename(instanceCode))

default_logger = _log(filename(default_file))

if __name__ == '__main__':
    default_logger.info("----info, 123")
    default_logger.error("----error, 123")
    default_logger.debug("----debug, 123")
    default_logger.critical("----critical, 123")