from ali_autodrive.parallel_compute.ParallelComputeManager import ParallelComputeManager
from ali_autodrive.parallel_compute.ExecutorAgentManager import ExecutorAgentManager
from ali_autodrive.parallel_compute.executor_agent.ExecutorServer import *
from ali_autodrive.parallel_compute.executor_agent.LogUtil import *

logger = get_log("parallel_compute_manager")


# 动态加载用户实现类
def __load_processor(imp_module, imp_class):
    module = __import__(imp_module, fromlist=(True,))
    return getattr(module, imp_class)


# 启动入口
if __name__ == '__main__':
    # 动态加载用户实现
    logger.info("Load processor.")
    processor = __load_processor(sys.argv[1], sys.argv[2])

    # 启动并行计算框架
    logger.info("Create parallel compute manager.")
    parallel_compute_manager = ParallelComputeManager(processor, logger)

    # 创建agentManager，注册并行处理框架
    logger.info("Create agent manager.")
    agent_manager = ExecutorAgentManager(parallel_compute_manager)

    # 注册agentManager
    logger.info("Register agent manager.")
    register(agent_manager)

    # 启动agent
    logger.info("Start agent manager.")
    start()

    # 判断是否开启debug模式，开启后模拟executor_agent及data_store
    # simulate()
