# 遍历该节点下所有文件列表，级联
def get_sub_node_file_list(node):
    sub_node_file_list = []
    if node is None or node["subNodes"] is None:
        return sub_node_file_list

    if "nodePath" in node:
        node_path = node["nodePath"]
    else:
        node_path = "/"

    for sub in node["subNodes"]:
        if sub["type"] == "file":
            sub_node_file_list.append(node_path + sub["name"])
        else:
            sub["nodePath"] = node_path + sub["name"] + "/"
            sub_node_file_list.extend(get_sub_node_file_list(sub))

    return sub_node_file_list


# 遍历该节点下所有本地文件列表，级联
def get_sub_node_local_file_list(node):
    sub_node_local_file_list = []
    if node is None or node["subNodes"] is None:
        return sub_node_local_file_list

    for sub in node["subNodes"]:
        if sub["type"] == "file":
            sub_node_local_file_list.append(sub["localFile"])
        else:
            sub_node_local_file_list.extend(get_sub_node_local_file_list(sub))

    return sub_node_local_file_list


# 遍历该节点下子节点列表
def get_sub_node_name_list(node):
    sub_node_name_list = []

    if node is None or node["subNodes"] is None:
        return sub_node_name_list

    for sub in node["subNodes"]:
        sub_node_name_list.append(sub["name"])

    return sub_node_name_list


# 获取指定子节点
def get_sub_node(node, sub_node_name):
    if node is None or node["subNodes"] is None:
        return None

    for sub in node["subNodes"]:
        if sub["name"] == sub_node_name:
            if "nodePath" in node:
                sub["nodePath"] = node["nodePath"] + sub["name"] + "/"
            else:
                sub["nodePath"] = "/" + sub["name"] + "/"
            return sub

    return None
